package com.example.fragmenttesting;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.Page;
import com.vaadin.server.Page.UriFragmentChangedListener;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.server.Page.UriFragmentChangedEvent;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Label;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

@SuppressWarnings("serial")
@Theme("fragmenttesting")
public class FragmenttestingUI extends UI {
	private int fragmentId = 1000;

	@WebServlet(value = "/*", asyncSupported = true)
	@VaadinServletConfiguration(productionMode = false, ui = FragmenttestingUI.class)
	public static class Servlet extends VaadinServlet {
	}

	private Label c;

	@Override
	protected void init(VaadinRequest request) {
		final VerticalLayout layout = new VerticalLayout();
		layout.setMargin(true);
		setContent(layout);

		Button button = new Button("Click Me 10 times, wait for ui to settle (10 seconds) then click the back button 10 times.");
		button.addClickListener(new Button.ClickListener() {


			public void buttonClick(ClickEvent event) {
				c = new Label("Thank you for clicking");
				layout.addComponent(c);
				Page.getCurrent().setUriFragment("FRAG"+(fragmentId++));
				

				

			}
		});
		layout.addComponent(button);
		
		
		Page.getCurrent().addUriFragmentChangedListener(new UriFragmentChangedListener() {
			
			@Override
			public void uriFragmentChanged(UriFragmentChangedEvent event) {

				new Thread() {
					public void run() {
						try {
							Thread.sleep(1000);
						} catch (InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						UI.getCurrent().access(new Runnable() {
							
							@Override
							public void run() {
								try {
									Thread.sleep(1000);
								} catch (InterruptedException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
								c.setCaption("Thread finished on "+fragmentId);
								// TODO Auto-generated method stub
								
							}
						});
						
					};
				}.start();
				c.setCaption("Thread running!");
				UI.getCurrent().setPollInterval(100);
			}
		});
	}

}